diff --git a/compose.c b/compose.c
index f2eb29b5fe..ec1df3a0ac 100644
--- a/compose.c
+++ b/compose.c
@@ -320,7 +320,7 @@ static void redraw_crypt_lines(struct Header *msg)
 
 #ifdef MIXMASTER
 
-static void redraw_mix_line(struct List *chain)
+static void redraw_mix_line(struct STailQHead *chain)
 {
   char *t = NULL;
 
@@ -329,16 +329,18 @@ static void redraw_mix_line(struct List *chain)
                        HeaderPadding[HDR_MIX], _(Prompts[HDR_MIX]));
   NORMAL_COLOR;
 
-  if (!chain)
+  if (STAILQ_EMPTY(chain))
   {
     addstr(_("<no chain defined>"));
     mutt_window_clrtoeol(MuttIndexWindow);
     return;
   }
 
-  for (int c = 12; chain; chain = chain->next)
+  int c = 12;
+  struct STailQNode *np;
+  STAILQ_FOREACH(np, chain, entries)
   {
-    t = chain->data;
+    t = np->data;
     if (t && t[0] == '0' && t[1] == '\0')
       t = "<random>";
 
@@ -346,7 +348,7 @@ static void redraw_mix_line(struct List *chain)
       break;
 
     addstr(NONULL(t));
-    if (chain->next)
+    if (STAILQ_NEXT(np, entries))
       addstr(", ");
 
     c += mutt_strlen(t) + 2;
@@ -445,7 +447,7 @@ static void draw_envelope(struct Header *msg, char *fcc)
     redraw_crypt_lines(msg);
 
 #ifdef MIXMASTER
-  redraw_mix_line(msg->chain);
+  redraw_mix_line(&msg->chain);
 #endif
 
   SETCOLOR(MT_COLOR_STATUS);
@@ -1288,7 +1290,7 @@ int mutt_compose_menu(struct Header *msg, /* structure for new message */
 
 
 #ifdef MIXMASTER
-        if (msg->chain && mix_check_message(msg) != 0)
+        if (!STAILQ_EMPTY(&msg->chain) && mix_check_message(msg) != 0)
           break;
 #endif
 
diff --git a/hcache/hcache.c b/hcache/hcache.c
index a99f4fa307..a788e96b9c 100644
--- a/hcache/hcache.c
+++ b/hcache/hcache.c
@@ -681,7 +681,7 @@ static void *hcache_dump(header_cache_t *h, struct Header *header, int *off,
   nh.tree = NULL;
   nh.thread = NULL;
 #ifdef MIXMASTER
-  nh.chain = NULL;
+  STAILQ_INIT(&nh.chain);
 #endif
 #if defined(USE_POP) || defined(USE_IMAP)
   nh.data = NULL;
diff --git a/header.h b/header.h
index 61340a8d87..f9a27d8fc8 100644
--- a/header.h
+++ b/header.h
@@ -27,6 +27,7 @@
 #include <stdbool.h>
 #include <time.h>
 #include "lib.h"
+#include "list.h"
 
 /**
  * struct Header - The header/envelope of an email
@@ -100,7 +101,7 @@ struct Header
   short attach_total;
 
 #ifdef MIXMASTER
-  struct List *chain;
+  struct STailQHead chain;
 #endif
 
 #ifdef USE_POP
@@ -117,7 +118,11 @@ struct Header
 
 static inline struct Header *mutt_new_header(void)
 {
-  return safe_calloc(1, sizeof(struct Header));
+  struct Header *h = safe_calloc(1, sizeof(struct Header));
+#ifdef MIXMASTER
+  STAILQ_INIT(&h->chain);
+#endif
+  return h;
 }
 
 #endif /* _MUTT_HEADER_H */
diff --git a/muttlib.c b/muttlib.c
index 4d0411043f..201c0f2fcb 100644
--- a/muttlib.c
+++ b/muttlib.c
@@ -420,7 +420,7 @@ void mutt_free_header(struct Header **h)
   FREE(&(*h)->tree);
   FREE(&(*h)->path);
 #ifdef MIXMASTER
-  mutt_free_list(&(*h)->chain);
+  mutt_free_stailq(&(*h)->chain);
 #endif
 #if defined(USE_POP) || defined(USE_IMAP) || defined(USE_NNTP) || defined(USE_NOTMUCH)
   if ((*h)->free_cb)
diff --git a/postpone.c b/postpone.c
index 6a8f11d707..79728c34bc 100644
--- a/postpone.c
+++ b/postpone.c
@@ -372,12 +372,15 @@ int mutt_get_postponed(struct Context *ctx, struct Header *hdr,
     else if (mutt_strncmp("X-Mutt-Mix:", np->data, 11) == 0)
     {
       char *t = NULL;
-      mutt_free_list(&hdr->chain);
+      mutt_free_stailq(&hdr->chain);
 
       t = strtok(np->data + 11, " \t\n");
+      struct STailQNode *n;
       while (t)
       {
-        hdr->chain = mutt_add_list(hdr->chain, t);
+        n = safe_calloc(1, sizeof(struct STailQNode));
+        n->data = safe_strdup(t);
+        STAILQ_INSERT_TAIL(&hdr->chain, n, entries);
         t = strtok(NULL, " \t\n");
       }
     }
diff --git a/remailer.c b/remailer.c
index 469e4ea6d2..c44b87f030 100644
--- a/remailer.c
+++ b/remailer.c
@@ -458,9 +458,8 @@ static const struct Mapping RemailerHelp[] = {
 };
 
 
-void mix_make_chain(struct List **chainp)
+void mix_make_chain(struct STailQHead *chainhead)
 {
-  struct List *p = NULL;
   struct MixChain *chain = NULL;
   int c_cur = 0, c_old = 0;
   bool c_redraw = true;
@@ -485,10 +484,13 @@ void mix_make_chain(struct List **chainp)
   }
 
   chain = safe_calloc(1, sizeof(struct MixChain));
-  for (p = *chainp; p; p = p->next)
-    mix_chain_add(chain, (char *) p->data, type2_list);
 
-  mutt_free_list(chainp);
+  struct STailQNode *p;
+  STAILQ_FOREACH(p, chainhead, entries)
+  {
+    mix_chain_add(chain, p->data, type2_list);
+  }
+  mutt_free_stailq(chainhead);
 
   /* safety check */
   for (i = 0; i < chain->cl; i++)
@@ -650,6 +652,7 @@ void mix_make_chain(struct List **chainp)
 
   if (chain->cl)
   {
+    struct STailQNode *n = NULL;
     for (i = 0; i < chain->cl; i++)
     {
       if ((j = chain->ch[i]))
@@ -657,7 +660,9 @@ void mix_make_chain(struct List **chainp)
       else
         t = "*";
 
-      *chainp = mutt_add_list(*chainp, t);
+      n = safe_calloc(1, sizeof(struct STailQNode));
+      n->data = safe_strdup(t);
+      STAILQ_INSERT_TAIL(chainhead, n, entries);
     }
   }
 
@@ -714,7 +719,7 @@ int mix_check_message(struct Header *msg)
   return 0;
 }
 
-int mix_send_message(struct List *chain, const char *tempfile)
+int mix_send_message(struct STailQHead *chain, const char *tempfile)
 {
   char cmd[HUGE_STRING];
   char tmp[HUGE_STRING];
@@ -723,11 +728,13 @@ int mix_send_message(struct List *chain, const char *tempfile)
 
   snprintf(cmd, sizeof(cmd), "cat %s | %s -m ", tempfile, Mixmaster);
 
-  for (i = 0; chain; chain = chain->next, i = 1)
+  struct STailQNode *np;
+  STAILQ_FOREACH(np, chain, entries)
   {
     strfcpy(tmp, cmd, sizeof(tmp));
-    mutt_quote_filename(cd_quoted, sizeof(cd_quoted), (char *) chain->data);
-    snprintf(cmd, sizeof(cmd), "%s%s%s", tmp, i ? "," : " -l ", cd_quoted);
+    mutt_quote_filename(cd_quoted, sizeof(cd_quoted), np->data);
+    snprintf(cmd, sizeof(cmd), "%s%s%s", tmp,
+        (np == STAILQ_FIRST(chain)) ? " -l " : ",", cd_quoted);
   }
 
   if (!option(OPTNOCURSES))
diff --git a/remailer.h b/remailer.h
index 6e3433d03f..e12a74a458 100644
--- a/remailer.h
+++ b/remailer.h
@@ -29,7 +29,7 @@
 
 #include <stddef.h>
 
-struct List;
+struct STailQHead;
 struct Header;
 
 #ifdef MIXMASTER
@@ -64,9 +64,9 @@ struct MixChain
   int ch[MAXMIXES];
 };
 
-int mix_send_message(struct List *chain, const char *tempfile);
+int mix_send_message(struct STailQHead *chain, const char *tempfile);
 int mix_check_message(struct Header *msg);
-void mix_make_chain(struct List **chainp);
+void mix_make_chain(struct STailQHead *chain);
 
 #endif /* MIXMASTER */
 
diff --git a/send.c b/send.c
index c50e083802..b9f9f3fada 100644
--- a/send.c
+++ b/send.c
@@ -1104,7 +1104,7 @@ static int send_message(struct Header *msg)
     unset_option(OPTWRITEBCC);
 #endif
 #ifdef MIXMASTER
-  mutt_write_rfc822_header(tempfp, msg->env, msg->content, 0, msg->chain ? 1 : 0);
+  mutt_write_rfc822_header(tempfp, msg->env, msg->content, 0, !STAILQ_EMPTY(&msg->chain));
 #endif
 #ifndef MIXMASTER
   mutt_write_rfc822_header(tempfp, msg->env, msg->content, 0, 0);
@@ -1131,8 +1131,8 @@ static int send_message(struct Header *msg)
   }
 
 #ifdef MIXMASTER
-  if (msg->chain)
-    return mix_send_message(msg->chain, tempfile);
+  if (!STAILQ_EMPTY(&msg->chain))
+    return mix_send_message(&msg->chain, tempfile);
 #endif
 
 #ifdef USE_SMTP
diff --git a/sendlib.c b/sendlib.c
index 2d6348fb72..aa4783ca33 100644
--- a/sendlib.c
+++ b/sendlib.c
@@ -3041,13 +3041,14 @@ int mutt_write_fcc(const char *path, struct Header *hdr, const char *msgid,
    * chain, save that information
    */
 
-  if (post && hdr->chain && hdr->chain)
+  if (post && !STAILQ_EMPTY(&hdr->chain))
   {
-    struct List *p = NULL;
-
     fputs("X-Mutt-Mix:", msg->fp);
-    for (p = hdr->chain; p; p = p->next)
+    struct STailQNode *p;
+    STAILQ_FOREACH(p, &hdr->chain, entries)
+    {
       fprintf(msg->fp, " %s", (char *) p->data);
+    }
 
     fputc('\n', msg->fp);
   }
